3 # Copyright (c) 2005 Junio C Hamano
6 test_description='the test framework itself.'
8 ################################################################
9 # It appears that people try to run tests without building...
11 if ! test -x ../notmuch
13 echo >&2 'You do not seem to have built notmuch yet.'
19 ################################################################
21 test_expect_success 'success is reported like this' '
24 test_set_prereq HAVEIT
26 test_expect_success HAVEIT 'test runs if prerequisite is satisfied' '
27 test_have_prereq HAVEIT &&
32 test_expect_success 'tests clean up after themselves' '
33 test_when_finished clean=yes
37 test_expect_code 1 'tests clean up even after a failure' '
38 test_when_finished cleaner=yes &&
42 if test $clean$cleaner != yesyes
44 say "bug in test framework: cleanup commands do not work reliably"
48 test_expect_code 2 'failure to clean up causes the test to fail' '
49 test_when_finished "(exit 2)"
52 EXPECTED=$TEST_DIRECTORY/test.expected-output
53 suppress_diff_date() {
54 sed -e 's/\(.*\-\-\- test-verbose\.4\.\expected\).*/\1/' \
55 -e 's/\(.*\+\+\+ test-verbose\.4\.\output\).*/\1/'
58 test_begin_subtest "Ensure that test output is suppressed unless the test fails"
59 output=$(cd $TEST_DIRECTORY; NOTMUCH_TEST_QUIET= ./test-verbose 2>&1 | suppress_diff_date)
60 expected=$(cat $EXPECTED/test-verbose-no | suppress_diff_date)
61 test_expect_equal "$output" "$expected"
63 test_begin_subtest "Ensure that -v does not suppress test output"
64 output=$(cd $TEST_DIRECTORY; NOTMUCH_TEST_QUIET= ./test-verbose -v 2>&1 | suppress_diff_date)
65 expected=$(cat $EXPECTED/test-verbose-yes | suppress_diff_date)
66 # Do not include the results of test-verbose in totals
67 rm $TEST_DIRECTORY/test-results/test-verbose
68 rm -r $TEST_DIRECTORY/tmp.test-verbose
69 test_expect_equal "$output" "$expected"
72 ################################################################
73 # Test mail store prepared in test-lib.sh
76 'test that mail store was created' \
77 'test -d "${MAIL_DIR}"'
80 find "${MAIL_DIR}" -type f -print >should-be-empty
82 'mail store should be empty' \
83 'cmp -s /dev/null should-be-empty'
86 'NOTMUCH_CONFIG is set and points to an existing file' \
87 'test -f "${NOTMUCH_CONFIG}"'
89 test_begin_subtest 'PATH is set to build directory'
91 "$(dirname ${TEST_DIRECTORY})" \
92 "$(echo $PATH|cut -f1 -d: | sed -e 's,/test/valgrind/bin$,,')"
94 test_begin_subtest 'notmuch is compiled with debugging symbols'
95 readelf --sections $(which notmuch) | grep \.debug
96 test_expect_equal 0 $?